#include <stdio.h>      
#include <stdlib.h> // Failikontrollis exit need it
#include <malloc.h> //   For dynamic memory

 

typedef struct {
    size_t stackSize;
    size_t stackPointer;
    float *items;
} PINU;

PINU *create(size_t st);
void sisselugemine(float *A);
float pop(PINU *ps);
void v2ljastus(float *A, PINU *ps, int arv);
float kysimus();
int liikmetearv();
float rekursioon(float *A, size_t abi);
void funktsioon(float *A, PINU *ps, int arv);

int main(void){
    int arv;
    arv=liikmetearv();
    float *A;       		// Creating an array A of numbers and giving m2lu. You could also make a separate function, but it doesn't make much sense to reduce one line of code in the main function
    A=(float*)malloc(sizeof(float)*arv);
    PINU *H = create(arv);   
    sisselugemine(A);
    funktsioon(A, H, arv);
    v2ljastus(A, H, arv);
    free(A);        	 
    free(H);
    getchar();
    return 0;
}

PINU *create(size_t st){         
    PINU *ps;
    ps = (PINU*) malloc (sizeof(PINU)*2);     
                                            //  A for loop to assign memory to each stack
    int i;
    for(i=0;i<2;i++){       //  
        (ps+i) -> stackSize = st;
        (ps+i) -> stackPointer = 0;
        (ps+i) -> items = (float*)malloc(sizeof(float) * ps -> stackSize);
    }
    return ps;
}

void sisselugemine(float *A){
    FILE *sisend;
    sisend=fopen("121090IA21_F1.txt","r");
    rewind(sisend);						//File back to top
    if(sisend==NULL){                    
        printf("Faili pole!\n");
        exit(1);
    }
    int i=0;
    while(!feof(sisend)){
        fscanf(sisend, "%f", (A+i));
        i++;
    }
    fclose(sisend);
}

float pop(PINU *ps) {
    return (ps+1)->items[(ps+1)->stackPointer];   //  TTo the output function returns items above (ps1)->stack Pointer--
}

void v2ljastus(float *A, PINU *ps, int arv){
    FILE *v2lja;
    v2lja=fopen("121090IA21_F2.txt","w");
    if(v2lja==NULL){                   l
        printf("There is no file!\n");
        exit(1);
    }
    while((ps+0)->stackPointer != -1){      // Here, members are moved from stack ps+0 to stack ps+1 to get the original order
        (ps+1)->items[(ps+1)->stackPointer]=(ps+0)->items[(ps+0)->stackPointer];
        if((ps+1)->stackPointer<arv-1){
            (ps+1)->stackPointer++;
        }
        (ps+0)->stackPointer--;
    }
    int i=0;
    float summa=1, element;
    while((ps+1)->stackPointer != 0){      //  The output is the same for both file and screen
		(ps+1)->stackPointer--;			//The pointer value is decremented to 0	
        element=pop(ps);         // pop function returns the result with return (function above n2ha)
        fprintf(v2lja, " %d Element H above  -   %.3f\n", i, element);
        printf("Element H kohal %d   -   %.3f\n", i, element);
        summa=*(A+i)*summa+element;
        
        i++;
    }
    printf("Summa Ai*Hi   -   %.3f\n", summa);
    fprintf(v2lja, "Summa Ai*Hi   -   %.3f\n", summa);
    fclose(v2lja);
}

float kysimus(){						//Added "function" subfunction to simplify
	float X;
	printf("\n Enter a real number X\n");
	scanf("%f", &X);
	return X;
}

int liikmetearv(){
	int i=0;
	float abi;
	FILE *sisend;
	sisend=fopen("121090IA21_F1.txt","r");
	if(sisend==NULL){                   //  Failikontroll
        printf("There is no file!\n");
        exit(1);
    }
    while(!feof(sisend)){
        fscanf(sisend, "%f", &abi);
        i++;
	}
	printf("\%d members were counted\n", i); 
	return i=10;
	fclose(sisend);
}

float rekursioon(float *A, size_t abi){
	int i;
	float vastus, y=1, x=1;
	for(i=0;i<abi;i++){
		y=(*(A+i))*y;
		if(i>0){
			x=i*x;
		}
	}
	vastus=y/x;
	return vastus;
}

void funktsioon(float *A, PINU *ps, int arv){
    int i;
    float X;
    X=kysimus();
    for(i=0;i<arv;i++){
		if ((ps+0)->stackPointer == 0){
            (ps+0)->items[0]=X;
		}
		if ((ps+0)->stackPointer != 0){
			(ps+0)->items[(ps+0)->stackPointer]=X*rekursioon(A, ((ps+0)->stackPointer));
			arv=arv-(ps+0)->stackPointer;//  It is done as long as there are A's in the recursion function, it is considered that more and more of them are used in the recursion.
															 
		}
		if (i<arv-1){      // Stackpointer must not be larger than the number of members, so n-1
            (ps+0)->stackPointer++;
        }
	}
    
}
